#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "boat1.h"

boat1::boat1()
{
	//default constructor, set all of the variables

	pos_y = 191;
	pos_x = 320;
	angle = 45;
	barrel_x0=pos_x*2+150;
	barrel_y0=pos_y-1;
	barrel_x1=pos_x*2+150+2*BARREL_LENGTH*cos((angle-180)*PI/180.0);
	barrel_y1=pos_y-1+BARREL_LENGTH*sin((angle-180)*PI/180.0);
	status=0;
}


boat1::~boat1()
{
	//deletes the image from the screen

	Destroy_BOB(&boat);
}

void boat1::Create()
{
	status=0;
	Load_Bitmap_File(&bitmap16bit, "graphics/boat1.bmp");
	Create_BOB(&boat,0,30+rand()%60,BOAT_WIDTH,BOAT_HEIGHT,3,BOB_ATTR_MULTI_FRAME | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY,0,16);
	Set_Anim_Speed_BOB(&boat, 1);
	Set_Vel_BOB(&boat, 2+rand()%6,0);
	Set_Pos_BOB(&boat, pos_x, pos_y);
	for (int index=0; index < 3; index++)
		Load_Frame_BOB16(&boat, &bitmap16bit, index, 0, index, BITMAP_EXTRACT_MODE_CELL);
	Unload_Bitmap_File(&bitmap16bit);
	
}


void boat1::Draw()
{
	// 0 = drawn
	// 1 = hit and loading new image
	// 2 = hit and drawing new image
	// 3 = sunk and loading new image
	// 4 = sunk and drawing new image

	if(status==0)
	{
//		Animate_BOB(&boat);
//		Draw_BOB16(&boat,lpddsback);
	}

	else if(status==1)
	{
		Load_Bitmap_File(&bitmap16bit, "graphics/boat2.bmp");  //damaged
		Destroy_BOB(&boat);
		Create_BOB(&boat,0,30+rand()%60,BOAT_WIDTH,BOAT_HEIGHT,3,BOB_ATTR_MULTI_FRAME | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY,0,16);
		Set_Anim_Speed_BOB(&boat, 1);
		Set_Vel_BOB(&boat, 2+rand()%6,0);
		Set_Pos_BOB(&boat, pos_x, pos_y);
		for (int index=0; index < 3; index++)
			Load_Frame_BOB16(&boat, &bitmap16bit, index, 0, index, BITMAP_EXTRACT_MODE_CELL);
		Unload_Bitmap_File(&bitmap16bit);
	}

/*	else if(status==2)
	{
		Animate_BOB(&boat);
		Draw_BOB16(&boat,lpddsback);
	}
*/
	else if(status==2)
	{
		Load_Bitmap_File(&bitmap16bit, "graphics/boat3.bmp");  //sunk
		Create_BOB(&boat,0,30+rand()%60,BOAT_WIDTH,BOAT_HEIGHT,3,BOB_ATTR_MULTI_FRAME | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY,0,16);
		Set_Anim_Speed_BOB(&boat, 1);
		Set_Vel_BOB(&boat, 2+rand()%6,0);
		Set_Pos_BOB(&boat, pos_x, pos_y);
		for (int index=0; index < 3; index++)
			Load_Frame_BOB16(&boat, &bitmap16bit, index, 0, index, BITMAP_EXTRACT_MODE_CELL);
		Unload_Bitmap_File(&bitmap16bit);
	}

/*	else if(status==4)
	{
		Animate_BOB(&boat);
		Draw_BOB16(&boat,lpddsback);
	}
*/
	Animate_BOB(&boat);
	Draw_BOB16(&boat,lpddsback);
	
	barrelDraw();

	// draw the bullet 2 at a time
	if(bullet_one.status)
		bullet_one.Draw();
	if(bullet_two.status)
		bullet_two.Draw();

	// draw the charges 3 at a time
	if(charge_one.status)
		charge_one.Draw();
	if(charge_two.status)
		charge_two.Draw();
	if(charge_three.status)
		charge_three.Draw();
}


//removes the bob
void boat1::Kill()
{
	
	
	Destroy_BOB(&boat);
}

void boat1::barrelDraw()//UCHAR *dest)
{
	DDraw_Lock_Back_Surface();

	//draw 3 lines to make it thicker
	Draw_Line(barrel_x0,barrel_y0,barrel_x1,barrel_y1,RGB(1,1,1),back_buffer,back_lpitch);
	Draw_Line(barrel_x0-1,barrel_y0,barrel_x1-1,barrel_y1,RGB(1,1,1),back_buffer,back_lpitch);
	Draw_Line(barrel_x0+1,barrel_y0,barrel_x1+1,barrel_y1,RGB(1,1,1),back_buffer,back_lpitch);

	//draw 1 line so it'll be thinner
	if(angle==0||angle==180)
		Draw_Line(barrel_x0,barrel_y0-1,barrel_x1,barrel_y1-1,RGB(1,1,1),back_buffer,back_lpitch);

	DDraw_Unlock_Back_Surface();
	DDraw_Flip();
}

// sets the position of the barrel for aim according to the angle
void boat1::BarrelLeft()
{
	angle-=5;
	if(angle <=0)
		angle = 0;

	//calculate the line according to the angle (convert into radians too)
	barrel_x0=pos_x*2+150;
	barrel_y0=pos_y-1;
	barrel_x1=pos_x*2+150+2*BARREL_LENGTH*cos((angle-180)*PI/180.0);
	barrel_y1=pos_y-1+BARREL_LENGTH*sin((angle-180)*PI/180.0);
}

// sets the position of the barrel for aim according to the angle
void boat1::BarrelRight()
{
	angle+=5;
	if(angle>180)
		angle = 180;
	
	//calculate the line according to the angle (convert into radians too)
	barrel_x0=pos_x*2+150;
	barrel_y0=pos_y-1;
	barrel_x1=pos_x*2+150+2*BARREL_LENGTH*cos((angle-180)*PI/180.0);
	barrel_y1=pos_y-1+BARREL_LENGTH*sin((angle-180)*PI/180.0);
}


bool boat1::FireWeaponUp()
{
	// draw only 2 at a time on the screen
	if(!bullet_one.status)
	{
		bullet_one.Create(pos_x,pos_y,angle);
		return true;
	}
	else if(!bullet_two.status)
	{
		bullet_two.Create(pos_x,pos_y,angle);
		return true;
	}
	else
		return false;
}

bool boat1::FireWeaponDown()
{
	// draw only 3 at a time on the screen
	if(!charge_one.status)
	{
		charge_one.Create(pos_x,pos_y,angle);
		return true;
	}
	else if(!charge_two.status)
	{
		charge_two.Create(pos_x,pos_y,angle);
		return true;
	}
	else if(!charge_three.status)
	{
		charge_three.Create(pos_x,pos_y,angle);
		return true;
	}
	else
		return false;
}

void boat1::MoveLeft()
{
	// move the boat 5 pixels then reposition the barrel as well
	pos_x-=5;
	if(pos_x<0)
		pos_x=0;
	Set_Pos_BOB(&boat, pos_x, pos_y);

	barrel_x0=pos_x*2+150;
	barrel_y0=pos_y-1;
	barrel_x1=pos_x*2+150+2*BARREL_LENGTH*cos((angle-180)*PI/180.0);
	barrel_y1=pos_y-1+BARREL_LENGTH*sin((angle-180)*PI/180.0);
}

void boat1::MoveRight()
{
	// move the boat 5 pixels then reposition the barrel as well
	pos_x+=5;
	if(pos_x >= SCREEN_WIDTH-BOAT_WIDTH)
		pos_x=SCREEN_WIDTH-BOAT_WIDTH;
	Set_Pos_BOB(&boat, pos_x, pos_y);

	barrel_x0=pos_x*2+150;
	barrel_y0=pos_y-1;  //barrel calculations
	barrel_x1=pos_x*2+150+2*BARREL_LENGTH*cos((angle-180)*PI/180.0);
	barrel_y1=pos_y-1+BARREL_LENGTH*sin((angle-180)*PI/180.0);
}

BOB boat1::bob()
{
	//returns the BOB boat
	BOB temp;
	temp=boat;
	return temp;
}
