// Destroyer Assault - Version 1.0
// By Rami Hamadeh and Brandon Hansen
// The University of Michigan - Dearborn
// CIS 487 - Dr. Bruce Maxim
// Fall 2002 - 12/17/2002

// INCLUDES ///////////////////////////////////////////////

#define INITGUID
#define WIN32_LEAN_AND_MEAN  

#include <windows.h>  // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <fstream.h>


#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "sub1.h"   // game includes
#include "boat1.h"
#include "plane1.h"
#include "intros.h"


// DEFINES ////////////////////////////////////////////////

#define WINDOW_CLASS_NAME "WINXCLASS"  // class name
#define WINDOW_TITLE      "Destroyer Assault"
#define WINDOW_WIDTH      640   // size of window
#define WINDOW_HEIGHT     480   // size of window
#define WINDOW_BPP        16    // bitdepth of window (8,16,24 etc.)
#define WINDOWED_APP      1     // 0 not windowed, 1 windowed
#define NUM_PLANES	      20    // max # of planes in the game
#define NUM_SUBMARINES    20    // max # of submarines in the game
#define ICON_DA	         104    // for game icon into the EXE


// PROTOTYPES /////////////////////////////////////////////

int Game_Init(void *parms=NULL);     // Initializes variables and DX
int Game_Shutdown(void *parms=NULL); // Runs when game is shutting down
int Game_Main(void *parms=NULL);     // Main Game Loop
void InitSounds();                   // Initializes the sounds
void kbInput();                      // Gets KB input and runs functions
void EndingLose(int totscore);       // when player loses
void Level1();                       // Level 1
void Level2();                       // Level 2
void Level3();                       // Level 3
void Level4();                       // Level 4
void Level5();                       // Level 5
void Detect1();                      // Detect submarine collisions
void Detect2();                      // Detect plane collisions
void DetectBoat();                   // Detect collisions with boat
void HighScore(int totscore);        // Display the high score history

// GLOBALS ////////////////////////////////////////////////

HWND main_window_handle = NULL; // save the window handle
HINSTANCE main_instance = NULL; // save the instance
char buffer[80];                // used to print text

BITMAP_IMAGE background_bmp;    // holds the background sky
BITMAP_IMAGE water_bmp;         // holds the background water
int sound_id[16];               // for sound effects
sub1 submarine[NUM_SUBMARINES]; // subs
boat1 boat;                     //one boat on the screen
plane1 plane[NUM_PLANES];       // planes
intros intro;          // intro sequences
int level=0;           // current level
int countsubs = 0;     // # subs drawn so far
int countplanes = 0;   // # planes drawn so far
int gotpast = 0;       // # objects passed by the boat
DWORD last_shot_bullet=0; // time variable, fire every 400ms
DWORD last_shot_charge=0; // time variable, fire every 400ms
int score=0;           // current score
int totscore=0;        // total score
int active1=0;         // first active object marker
int active2=1;         // second active object marker
int active21=0;        // first active object marker
int active22=1;        // second active object marker
int LEVEL1_SUBS=13;    // number of subs in level 1
int LEVEL2_PLANES=10;  // number of planes in level 2
int LEVEL3_SUBS=8;     // number of subs in level 3
int LEVEL3_PLANES=7;   // number of planes in level 3
int LEVEL4_SUBS=10;    // number of subs in level 4
int LEVEL4_PLANES=15;  // number of planes in level 4
int LEVEL5_SUBS=15;    // number of subs in level 5
int LEVEL5_PLANES=15;  // number of planes in level 5
int highscores[6];     // array that holds the high scores history
ifstream inFile;       // input file of the high scores history
int firstrun=true;     // first pass-through variable used for each level

// FUNCTIONS //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
							UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
	// this is the main message handler of the system
	PAINTSTRUCT	ps;		   // used in WM_PAINT
	HDC			hdc;	   // handle to a device context
	
	// what is the message 
	switch(msg)
	{	
	case WM_CREATE: 
        {
			// do initialization stuff here
			return(0);
		} break;
		
    case WM_PAINT:
		{
			// start painting
			hdc = BeginPaint(hwnd,&ps);
			
			// end painting
			EndPaint(hwnd,&ps);
			return(0);
        } break;
		
	case WM_DESTROY: 
		{
			// kill the application			
			PostQuitMessage(0);
			return(0);
		} break;
		
	default:break;
		
    } // end switch
	
	// process any messages that we didn't take care of 
	return (DefWindowProc(hwnd, msg, wparam, lparam));
	
} // end WinProc



// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
				   HINSTANCE hprevinstance,
				   LPSTR lpcmdline,
				   int ncmdshow)
{
	// this is the winmain function
	
	WNDCLASSEX winclass; // this will hold the class we create
	HWND	   hwnd;	 // generic window handle
	MSG		   msg;		 // generic message
//	HDC        hdc;      // graphics device context
	
	// first fill in the window class stucture
	winclass.cbSize         = sizeof(WNDCLASSEX);
	winclass.style			= CS_DBLCLKS | CS_OWNDC | 
		CS_HREDRAW | CS_VREDRAW;
	winclass.lpfnWndProc	= WindowProc;
	winclass.cbClsExtra		= 0;
	winclass.cbWndExtra		= 0;
	winclass.hInstance		= hinstance;
	winclass.hIcon			= LoadIcon(hinstance, MAKEINTRESOURCE(ICON_DA));
	winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
	winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	winclass.lpszMenuName	= NULL;
	winclass.lpszClassName	= WINDOW_CLASS_NAME;
	winclass.hIconSm        = LoadIcon(hinstance, MAKEINTRESOURCE(ICON_DA));
	
	// save hinstance in global
	main_instance = hinstance;
	
	// register the window class
	if (!RegisterClassEx(&winclass))
		return(0);
	
	// create the window
	if (!(hwnd = CreateWindowEx(NULL,                  // extended style
		WINDOW_CLASS_NAME,     // class
		WINDOW_TITLE, // title
		(WINDOWED_APP ? (WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION) : (WS_POPUP | WS_VISIBLE)), 
		0,0,	  // initial x,y
		WINDOW_WIDTH,WINDOW_HEIGHT,  // initial width, height
		NULL,	  // handle to parent 
		NULL,	  // handle to menu
		hinstance,// instance of this application
		NULL)))	// extra creation parms
		return(0);
	
	// save main window handle
	main_window_handle = hwnd;
	
	if (WINDOWED_APP)
	{
		// now resize the window, so the client area is the actual size requested
		// since there may be borders and controls if this is going to be a windowed app
		// if the app is not windowed then it won't matter
		RECT window_rect = {0,0,WINDOW_WIDTH-1,WINDOW_HEIGHT-1};
		
		// make the call to adjust window_rect
		AdjustWindowRectEx(&window_rect,
			GetWindowStyle(main_window_handle),
			GetMenu(main_window_handle) != NULL,
			GetWindowExStyle(main_window_handle));
		
		// save the global client offsets, they are needed in DDraw_Flip()
		window_client_x0 = -window_rect.left;
		window_client_y0 = -window_rect.top;
		
		// now resize the window with a call to MoveWindow()
		MoveWindow(main_window_handle,
			0, // x position
			0, // y position
			window_rect.right - window_rect.left, // width
			window_rect.bottom - window_rect.top, // height
			TRUE);
		
		// show the window, so there's no garbage on first render
		ShowWindow(main_window_handle, SW_SHOW);
	} // end if windowed
	
	// perform all game console specific initialization
	Game_Init();
	
	// enter main event loop
	while(1)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
			// test if this is a quit
			if (msg.message == WM_QUIT)
				break;
			
			// translate any accelerator keys
			TranslateMessage(&msg);
			
			// send the message to the window proc
			DispatchMessage(&msg);
		} // end if
		
		// main game processing goes here
		Game_Main();
		
	} // end while
	
	// shutdown game and release all resources
	Game_Shutdown();
	
	// return to Windows like this
	return(msg.wParam);
	
} // end WinMain


// WIN T3D GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms)
{
	// this function is where you do all the initialization 
	// for your game
	
	int index=0; // looping varsIable
	
//	char filename[80]; // used to build up filenames
	
	// seed random number generate
	srand(Start_Clock());
	
	// initialize directdraw, very important that in the call
	// to setcooperativelevel that the flag DDSCL_MULTITHREADED is used
	// which increases the response of directX graphics to
	// take the global critical section more frequently
	DDraw_Init(WINDOW_WIDTH, WINDOW_HEIGHT, WINDOW_BPP, WINDOWED_APP);

	// initialize directinput
	DInput_Init();
	
	// acquire the keyboard only
	DInput_Init_Keyboard();
	
	// initilize DirectSound
	DSound_Init();

	//loads all of the wavs into memory
	InitSounds();
	
	inFile.open("highscores.dat"); //load the high scores
	while (inFile)
	{
		inFile >> highscores[index++];
	}
	inFile.close();
	
	// hide the mouse
	if (!WINDOWED_APP)
		ShowCursor(FALSE);
	
	// return success
	return(1);
	
} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms)
{
	
	
	// shutdown directdraw last
	DDraw_Shutdown();
	
	// now directsound
	DSound_Stop_All_Sounds();
	DSound_Shutdown();
	
	// shut down directinput
	DInput_Shutdown();
	
	// return success
	return(1);
	
} // end Game_Shutdown

//////////////////////////////////////////////////////////
int Game_Main(void *parms)
{
//	Level1();
	switch (level)
	{
	case 0:  //play the intros
		totscore=0; //reset the total score
		intro.IntroGame(sound_id[0],sound_id[9],sound_id[14], sound_id[11]);
		intro.Intro1();
		level=1;
		break;

	case 1:  //play the first level
		Level1();
		break;		

	case 2:  //play the 2nd level info
		intro.Intro2(sound_id[13]);
		level =3;
		break;
	
	case 3:  //play the 2nd level
		Level2();
		break;
	
	case 4:  //play the third level info
		intro.Intro3(sound_id[13]);
		level =5;
		break;
	
	case 5:  //play the third level
		Level3();
		break;
	
	case 6:  //play the fourth level info
		intro.Intro4(sound_id[13]);
		level =7;
		break;
	
	case 7:  //play the fourth level
		Level4();
		break;
	
	case 8:  //play the fifth level info
		intro.Intro5(sound_id[13]);
		level =9;
		break;
	
	case 9:  //play the fifth level
		Level5();
		break;
	
	case 10:  //play the game ending if a win
		intro.Ending(sound_id[1]);
		HighScore(totscore);
		break;
		
	default:  //else exit game
		break;
	}
	
	DDraw_Flip();
	Wait_Clock(33);
	
	// return success
	return 1;
}


void Level1()
{
	if(firstrun)
	{
		// load background image
		Load_Bitmap_File(&bitmap16bit, "graphics/sky1.bmp");
		Create_Bitmap(&background_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&background_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);
	
		Load_Bitmap_File(&bitmap16bit, "graphics/water1.bmp");
		Create_Bitmap(&water_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&water_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);

		DSound_Play(sound_id[1],DSBPLAY_LOOPING); //load the bg music
		
		//load subs
		for (int x =0; x<20; x++)
		{
			submarine[x].Create();
			submarine[x].status=0;
		}
		
		//create the boat
		boat.Create();

		firstrun=false;
	}

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	// lock back buffer and copy background into it
	DDraw_Lock_Back_Surface();

	// draw background
	Draw_Bitmap16(&background_bmp, back_buffer, back_lpitch,0);
	Draw_Bitmap16(&water_bmp, back_buffer, back_lpitch,1);
	
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	
	// scroll the background
	Scroll_Bitmap(&background_bmp, -1);
	Scroll_Bitmap(&water_bmp, 1);
	
	// read keyboard
	kbInput();

	// draw the title
	sprintf(buffer, "Level 1 - Score: %d Passed: %d", score,gotpast);
	Draw_Text_GDI(buffer,5, 5,RGB(0,0,0), lpddsback);

	sprintf(buffer, "Total Score: %d", totscore);
	Draw_Text_GDI(buffer,540, 460,RGB(0,0,0), lpddsback);
	
	// move and animate the fleet
	if (active1 <LEVEL1_SUBS-1) 
	{
		submarine[active1].Move();
	}
	if (active2 < LEVEL1_SUBS-1)
	{
		submarine[active2].Move();
	}

	// move the last sub
	if (active1==LEVEL1_SUBS-1)
	{
		submarine[active1].Move();
	}
	else if (active2==LEVEL1_SUBS-1)
	{
		submarine[active2].Move();
	}

	boat.Draw();
	Detect1();  //detect colisions
	
	//got away 1
	if (submarine[active1].status==1)
	{
		if (submarine[active1].GetPosition() >= SCREEN_WIDTH-2)
		{
			submarine[active1].Kill();
			gotpast++;
			if (active1<active2)
				active1=active2+1;
			else if(active1)
				active1++;
		}
	}
	else if (submarine[active1].status==2)
	{
		if (active1<active2)
			active1=active2+1;
		else if(active1)
			active1++;
	}


	//got away 2
	if (submarine[active2].status==1)
	{
		if (submarine[active2].GetPosition() >= SCREEN_WIDTH-2)
		{
			submarine[active2].Kill();
			gotpast++;
			if (active2<active1)
				active2=active1+1;
			else if(active2)
				active2++;
		}	
	}
	else if (submarine[active2].status==2)
	{
		if (active2<active1)
			active2=active1+1;
		else if(active2)
			active2++;
	}

	// make sure all dead subs are sinking
	for (int i =0; i < LEVEL1_SUBS; i++)
	{
		if (submarine[i].status==2)
			submarine[i].Kill();
	}


	// check if user wants to exit
	if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
	{
		PostMessage(main_window_handle, WM_DESTROY,0,0);
		
		// stop all sounds
		DSound_Stop_All_Sounds();
		
	} // end if
	
	// move to the next level
	int j=0;
	for (int z=0; z<LEVEL1_SUBS;z++)
		j+=submarine[z].status;

	if (gotpast>=3)
	{
		//totscore+=score;
		Sleep(500);
		EndingLose(totscore);
		firstrun=true;
		//return;
	}
	//move onto the next level
	if(score+gotpast==LEVEL1_SUBS)
	{
		level =2;
		firstrun=true;
		DSound_Stop_All_Sounds();
		gotpast=0;
		//totscore+=score;
		score=0;
		active1=0;
		active2=1;
	}
}

void Level2()
{
	if(firstrun)
	{
		// load background image
		Load_Bitmap_File(&bitmap16bit, "graphics/sky1.bmp");
		Create_Bitmap(&background_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&background_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);
	
		Load_Bitmap_File(&bitmap16bit, "graphics/water1.bmp");
		Create_Bitmap(&water_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&water_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);

		DSound_Play(sound_id[2],DSBPLAY_LOOPING); //load the bg music
		
		//load subs
		for (int x =0; x<LEVEL2_PLANES; x++)
		{
			plane[x].Create();
			plane[x].status=0;
		}

		boat.Create();
		firstrun=false;
	}

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	// lock back buffer and copy background into it
	DDraw_Lock_Back_Surface();

	// draw background
	Draw_Bitmap16(&background_bmp, back_buffer, back_lpitch,0);
	Draw_Bitmap16(&water_bmp, back_buffer, back_lpitch,1);
	
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	
	// scroll the background
	Scroll_Bitmap(&background_bmp, 1);
	Scroll_Bitmap(&water_bmp, -1);
	
	// read keyboard
	kbInput();

	// draw the title
	sprintf(buffer, "Level 2 - Score: %d Passed: %d", score,gotpast);
	Draw_Text_GDI(buffer,5, 5,RGB(0,0,0), lpddsback);

	sprintf(buffer, "Total Score: %d", totscore);
	Draw_Text_GDI(buffer,540, 460,RGB(0,0,0), lpddsback);
	
	// move and animate the fleet
	if (active1 <LEVEL2_PLANES-1) 
	{
		plane[active1].Move();
	}
	if (active2 < LEVEL2_PLANES-1)
	{
		plane[active2].Move();
	}
	// move the last sub
	if (active1==LEVEL2_PLANES-1)
	{
		plane[active1].Move();
	}
	else if (active2==LEVEL2_PLANES-1)
	{
		plane[active2].Move();
	}

	boat.Draw();
	Detect2();  //detect colissions
	DetectBoat();
	
	//got away 1
	if (plane[active1].status==1)
	{
		if (plane[active1].GetPosition() >= SCREEN_WIDTH-2)
		{
			plane[active1].Kill();
			gotpast++;
			if (active1<active2)
				active1=active2+1;
			else if(active1)
				active1++;
		}
	}
	else if (plane[active1].status==2)
	{
		if (active1<active2)
			active1=active2+1;
		else if(active1)
			active1++;
	}


	//got away 2
	if (plane[active2].status==1)
	{
		if (plane[active2].GetPosition() >= SCREEN_WIDTH-2)
		{
			//submarine[active2].status=0;
			plane[active2].Kill();
			gotpast++;
			if (active2<active1)
				active2=active1+1;
			else if(active2)
				active2++;
		}	
	}
	else if (plane[active2].status==2)
	{
		if (active2<active1)
			active2=active1+1;
		else if(active2)
			active2++;
	}

	// make sure all dead planes are sinking
	for (int i =0; i < LEVEL2_PLANES; i++)
	{
		if (plane[i].status>=2)
			plane[i].Kill();
	}


	// check if user wants to exit
	if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
	{
		PostMessage(main_window_handle, WM_DESTROY,0,0);
		
		// stop all sounds
		DSound_Stop_All_Sounds();
		
	} // end if

	// move to the next level
	int j;
	for (int z=0; z<LEVEL2_PLANES;z++)
		j+=plane[z].status;

	if (gotpast>=5 || boat.status==2)
	{
		Sleep(500);
		//totscore+=score;
		DDraw_Flip();
		EndingLose(totscore);
		return;
		
	}
	//win
	if(score+gotpast==LEVEL2_PLANES)
	{
		level =4;
		firstrun=true;
		gotpast=0;
		active1=0;
		active2=1;
		//totscore+=score;
		score=0;
		for(int i=0; i < NUM_PLANES; i++)
			plane[i].status=0;
		DSound_Stop_All_Sounds();
	}

}

void Level3()
{
	if(firstrun)
	{	
		Load_Bitmap_File(&bitmap16bit, "graphics/water3.bmp");
		Create_Bitmap(&water_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&water_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);

		DSound_Play(sound_id[3],DSBPLAY_LOOPING); //load the bg music
		
		//load subs
		for (int x =0; x<LEVEL3_SUBS; x++)
		{
			submarine[x].Create();
			submarine[x].status=0;
		}
		for (x=0; x<LEVEL3_PLANES; x++)
		{
			plane[x].Create();
			plane[x].status=0;
		}

		boat.Create();
		firstrun=false;
	}

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	// lock back buffer and copy background into it
	DDraw_Lock_Back_Surface();

	// draw background
	Draw_Bitmap16(&water_bmp, back_buffer, back_lpitch,1);
	
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	
	// scroll the background
	Scroll_Bitmap(&water_bmp, -1);
	
	// read keyboard
	kbInput();

	// draw the title
	sprintf(buffer, "Level 3 - Score: %d Passed: %d", score,gotpast);
	Draw_Text_GDI(buffer,5, 5,RGB(0,0,0), lpddsback);

	sprintf(buffer, "Total Score: %d", totscore);
	Draw_Text_GDI(buffer,540, 460,RGB(0,0,0), lpddsback);

	// move and animate the fleet
	if (active1 <LEVEL3_PLANES-1)
	{
		plane[active1].Move();
	}
	if (active2 < LEVEL3_PLANES-1)
	{
		plane[active2].Move();
	}
	if (active21 <LEVEL3_SUBS-1)
		submarine[active21].Move();
	if (active22 <LEVEL3_SUBS-1)
		submarine[active22].Move();

	if (active1==LEVEL3_PLANES-1)
	{
		plane[active1].Move();
	}
	else if (active2==LEVEL3_PLANES-1)
	{
		plane[active2].Move();
	}
	if (active21==LEVEL3_SUBS-1)
		submarine[active21].Move();
	else if (active22==LEVEL3_SUBS-1)
		submarine[active22].Move();

	boat.Draw();
	Detect1();
	Detect2();  //detect colisions
	DetectBoat();
	
	//got away 1
	if (plane[active1].status==1)
	{
		if (plane[active1].GetPosition() >= SCREEN_WIDTH-2)
		{
			//submarine[active1].status=0;
			plane[active1].Kill();
			gotpast++;
			if (active1<active2)
				active1=active2+1;
			else if(active1)
				active1++;
		}
	}
	else if (plane[active1].status==2)
	{
		if (active1<active2)
			active1=active2+1;
		else if(active1)
			active1++;
	}


	//got away 2
	if (plane[active2].status==1)
	{
		if (plane[active2].GetPosition() >= SCREEN_WIDTH-2)
		{
			plane[active2].Kill();
			gotpast++;
			if (active2<active1)
				active2=active1+1;
			else if(active2)
				active2++;
		}	
	}
	else if (plane[active2].status==2)
	{
		if (active2<active1)
			active2=active1+1;
		else if(active2)
			active2++;
	}

	// make sure all dead subs are sinking
	for (int i =0; i < LEVEL3_PLANES; i++)
	{
		if (plane[i].status>=2)
			plane[i].Kill();
	}

	if (submarine[active21].status==1)
	{
		if (submarine[active21].GetPosition() >= SCREEN_WIDTH-2)
		{
			submarine[active21].Kill();
			gotpast++;
			if (active21<active22)
				active21=active22+1;
			else if(active21)
				active21++;
		}
	}
	else if (submarine[active21].status==2)
	{
		if (active21<active22)
			active21=active22+1;
		else if(active21)
			active21++;
	}


	//got away 2
	if (submarine[active22].status==1)
	{
		if (submarine[active22].GetPosition() >= SCREEN_WIDTH-2)
		{
			submarine[active22].Kill();
			gotpast++;
			if (active22<active21)
				active22=active21+1;
			else if(active22)
				active22++;
		}	
	}
	else if (submarine[active22].status==2)
	{
		if (active22<active21)
			active22=active21+1;
		else if(active22)
			active22++;
	}

	// make sure all dead subs are sinking
	for (i =0; i < LEVEL3_SUBS; i++)
	{
		if (submarine[i].status>=2)
			submarine[i].Kill();
	}


	// check if user wants to exit
	if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
	{
		PostMessage(main_window_handle, WM_DESTROY,0,0);
		
		// stop all sounds
		DSound_Stop_All_Sounds();
		
	} // end if

	// move to the next level
	int j;
	for (int z=0; z<LEVEL2_PLANES;z++)
		j+=plane[z].status;

	if (gotpast>=5 || boat.status==2)
	{
		boat.Draw();
		Sleep(500);
		//totscore+=score;
		DDraw_Flip();
		EndingLose(totscore);
		return;
		
	}
	// win
	if(score+gotpast==LEVEL3_PLANES+LEVEL3_SUBS)
	{
		level =6;
		firstrun=true;
		gotpast=0;
		score=0;
		//totscore+=score;
		for(int i=0; i < NUM_PLANES; i++)
			plane[i].status=0;
		active1=0;
		active2=1;
		active21=0;
		active22=1;
		DSound_Stop_All_Sounds();
	}
}


void Level4()
{
	if(firstrun)
	{
		// load background image
		Load_Bitmap_File(&bitmap16bit, "graphics/water4.bmp");
		Create_Bitmap(&water_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&water_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);

		DSound_Play(sound_id[4],DSBPLAY_LOOPING); //load the bg music
		
		//load subs
		for (int x =0; x<LEVEL4_SUBS; x++)
		{
			submarine[x].Create();
			submarine[x].status=0;
		}
		for (x=0; x<LEVEL4_PLANES; x++)
		{
			plane[x].Create();
			plane[x].status=0;
		}

		boat.Create();
		firstrun=false;
	}

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	// lock back buffer and copy background into it
	DDraw_Lock_Back_Surface();

	// draw background
	Draw_Bitmap16(&water_bmp, back_buffer, back_lpitch,1);
	
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	
	// scroll the background
	Scroll_Bitmap(&water_bmp, 1);
	
	// read keyboard
	kbInput();

	// draw the title
	sprintf(buffer, "Level 4 - Score: %d Passed: %d", score,gotpast);
	Draw_Text_GDI(buffer,5, 5,RGB(0,0,0), lpddsback);

	sprintf(buffer, "Total Score: %d", totscore);
	Draw_Text_GDI(buffer,540, 460,RGB(0,0,0), lpddsback);

	// move and animate the fleet
	if (active1 <LEVEL4_PLANES-1)
	{
		plane[active1].Move();
	}
	if (active2 < LEVEL4_PLANES-1)
	{
		plane[active2].Move();
	}
	if (active21 <LEVEL4_SUBS-1)
		submarine[active21].Move();
	if (active22 <LEVEL4_SUBS-1)
		submarine[active22].Move();

	// move the last sub
	if (active1==LEVEL4_PLANES-1)
	{
		plane[active1].Move();
	}
	else if (active2==LEVEL4_PLANES-1)
	{
		plane[active2].Move();
	}
	if (active21==LEVEL4_SUBS-1)
		submarine[active21].Move();
	else if (active22==LEVEL4_SUBS-1)
		submarine[active22].Move();

	boat.Draw();
	Detect1();
	Detect2();  //detect colisions
	DetectBoat();
	
	//got away 1
	if (plane[active1].status==1)
	{
		if (plane[active1].GetPosition() >= SCREEN_WIDTH-2)
		{
			plane[active1].Kill();
			gotpast++;
			if (active1<active2)
				active1=active2+1;
			else if(active1)
				active1++;
		}
	}
	else if (plane[active1].status==2)
	{
		if (active1<active2)
			active1=active2+1;
		else if(active1)
			active1++;
	}


	//got away 2
	if (plane[active2].status==1)
	{
		if (plane[active2].GetPosition() >= SCREEN_WIDTH-2)
		{
			plane[active2].Kill();
			gotpast++;
			if (active2<active1)
				active2=active1+1;
			else if(active2)
				active2++;
		}	
	}
	else if (plane[active2].status==2)
	{
		if (active2<active1)
			active2=active1+1;
		else if(active2)
			active2++;
	}

	// make sure all dead subs are sinking
	for (int i =0; i < LEVEL4_PLANES; i++)
	{
		if (plane[i].status>=2)
			plane[i].Kill();
	}

	if (submarine[active21].status==1)
	{
		if (submarine[active21].GetPosition() >= SCREEN_WIDTH-2)
		{
			submarine[active21].Kill();
			gotpast++;
			if (active21<active22)
				active21=active22+1;
			else if(active21)
				active21++;
		}
	}
	else if (submarine[active21].status==2)
	{
		if (active21<active22)
			active21=active22+1;
		else if(active21)
			active21++;
	}


	//got away 2
	if (submarine[active22].status==1)
	{
		if (submarine[active22].GetPosition() >= SCREEN_WIDTH-2)
		{
			submarine[active22].Kill();
			gotpast++;
			if (active22<active21)
				active22=active21+1;
			else if(active22)
				active22++;
		}	
	}
	else if (submarine[active22].status==2)
	{
		if (active22<active21)
			active22=active21+1;
		else if(active22)
			active22++;
	}

	// make sure all dead subs are sinking
	for (i =0; i < LEVEL4_SUBS; i++)
	{
		if (submarine[i].status>=2)
			submarine[i].Kill();
	}


	// check if user wants to exit
	if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
	{
		PostMessage(main_window_handle, WM_DESTROY,0,0);
		
		// stop all sounds
		DSound_Stop_All_Sounds();
		
	} // end if

	// move to the next level
	int j;
	for (int z=0; z<LEVEL4_PLANES;z++)
		j+=plane[z].status;

	if (gotpast>=5|| boat.status==2)
	{
		Sleep(500);
		//totscore+=score;
		DDraw_Flip();
		EndingLose(totscore);
		return;
	}
	// win
	if(score+gotpast==LEVEL4_PLANES+LEVEL4_SUBS)
	{
		level =8;
		firstrun=true;
		gotpast=0;
		score=0;
		//totscore+=score;
		for(int i=0; i < NUM_PLANES; i++)
			plane[i].status=0;		
		active1=0;
		active2=1;
		active21=0;
		active22=1;
		DSound_Stop_All_Sounds();
	}

	
}

void Level5()
{
	if(firstrun)
	{
		// load background image
		Load_Bitmap_File(&bitmap16bit, "graphics/sky1.bmp");
		Create_Bitmap(&background_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&background_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);
	
		Load_Bitmap_File(&bitmap16bit, "graphics/water1.bmp");
		Create_Bitmap(&water_bmp,0,0,640,480,16);
		Load_Image_Bitmap16(&water_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);

		DSound_Play(sound_id[5],DSBPLAY_LOOPING); //load the bg music
		
		//load subs
		for (int x =0; x<LEVEL5_SUBS; x++)
		{
			submarine[x].Create();
			submarine[x].status=0;
		}
		for (x=0; x<LEVEL5_PLANES; x++)
		{
			plane[x].Create();
			plane[x].status=0;
		}

		boat.Create();
		firstrun=false;
	}

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	// lock back buffer and copy background into it
	DDraw_Lock_Back_Surface();

	// draw background
	Draw_Bitmap16(&background_bmp, back_buffer, back_lpitch,0);
	Draw_Bitmap16(&water_bmp, back_buffer, back_lpitch,1);
	
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	
	// scroll the background
	Scroll_Bitmap(&background_bmp, 1);
	Scroll_Bitmap(&water_bmp, -1);
	
	// read keyboard
	kbInput();

	// draw the title
	sprintf(buffer, "Level 5 - Score: %d Passed: %d", score,gotpast);
	Draw_Text_GDI(buffer,5, 5,RGB(0,0,0), lpddsback);

	sprintf(buffer, "Total Score: %d", totscore);
	Draw_Text_GDI(buffer,540, 460,RGB(0,0,0), lpddsback);

		// move and animate the fleet
	if (active1 <LEVEL5_PLANES-1) 
	{
		plane[active1].Move();
	}
	if (active2 < LEVEL5_PLANES-1)
	{
		plane[active2].Move();
	}
	if (active21 <LEVEL5_SUBS-1)
		submarine[active21].Move();
	if (active22 <LEVEL5_SUBS-1)
		submarine[active22].Move();

	// move the last sub
	if (active1==LEVEL5_PLANES-1)
	{
		plane[active1].Move();
	}
	else if (active2==LEVEL5_PLANES-1)
	{
		plane[active2].Move();
	}
	if (active21==LEVEL5_SUBS-1)
		submarine[active21].Move();
	else if (active22==LEVEL5_SUBS-1)
		submarine[active22].Move();

	boat.Draw();
	Detect1();
	Detect2();  //detect colisions
	DetectBoat();
	
	//got away 1
	if (plane[active1].status==1)
	{
		if (plane[active1].GetPosition() >= SCREEN_WIDTH-2)
		{
			plane[active1].Kill();
			gotpast++;
			if (active1<active2)
				active1=active2+1;
			else if(active1)
				active1++;
		}
	}
	else if (plane[active1].status==2)
	{
		if (active1<active2)
			active1=active2+1;
		else if(active1)
			active1++;
	}


	//got away 2
	if (plane[active2].status==1)
	{
		if (plane[active2].GetPosition() >= SCREEN_WIDTH-2)
		{
			plane[active2].Kill();
			gotpast++;
			if (active2<active1)
				active2=active1+1;
			else if(active2)
				active2++;
		}	
	}
	else if (plane[active2].status==2)
	{
		if (active2<active1)
			active2=active1+1;
		else if(active2)
			active2++;
	}

	// make sure all dead subs are sinking
	for (int i =0; i < LEVEL5_PLANES; i++)
	{
		if (plane[i].status>=2)
			plane[i].Kill();
	}

	if (submarine[active21].status==1)
	{
		if (submarine[active21].GetPosition() >= SCREEN_WIDTH-2)
		{
			submarine[active21].Kill();
			gotpast++;
			if (active21<active22)
				active21=active22+1;
			else if(active21)
				active21++;
		}
	}
	else if (submarine[active21].status==2)
	{
		if (active21<active22)
			active21=active22+1;
		else if(active21)
			active21++;
	}


	//got away 2
	if (submarine[active22].status==1)
	{
		if (submarine[active22].GetPosition() >= SCREEN_WIDTH-2)
		{
			//submarine[active2].status=0;
			submarine[active22].Kill();
			gotpast++;
			if (active22<active21)
				active22=active21+1;
			else if(active22)
				active22++;
		}	
	}
	else if (submarine[active22].status==2)
	{
		if (active22<active21)
			active22=active21+1;
		else if(active22)
			active22++;
	}

	// make sure all dead subs are sinking
	for (i =0; i < LEVEL5_SUBS; i++)
	{
		if (submarine[i].status>=2)
			submarine[i].Kill();
	}


	// check if user wants to exit
	if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
	{
		PostMessage(main_window_handle, WM_DESTROY,0,0);
		
		// stop all sounds
		DSound_Stop_All_Sounds();
		
	} // end if

	// move to the next level
	int j;
	for (int z=0; z<LEVEL5_PLANES;z++)
		j+=plane[z].status;

	if (gotpast>=1 || boat.status==2)
	{
		Sleep(500);
		//totscore+=score;
		DDraw_Flip();
		EndingLose(totscore);
		return;
	}
	
	if(score+gotpast==LEVEL5_PLANES+LEVEL5_SUBS)
	{
		level =10;
		firstrun=true;
		gotpast=0;
		score=0;
		//totscore+=score;
		for(int i=0; i < NUM_PLANES; i++)
			plane[i].status=0;
		active1=0;
		active2=1;
		active21=0;
		active22=1;
		DSound_Stop_All_Sounds();
	}

	
}


void EndingLose(int totscore) //when player loses
{
	DWORD time=0;
	Load_Bitmap_File(&bitmap16bit, "graphics/gameover.bmp");
	Create_Bitmap(&background_bmp,0,0,640,480,16);
	Load_Image_Bitmap16(&background_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
	Unload_Bitmap_File(&bitmap16bit);
	DDraw_Lock_Back_Surface();

	// draw background
	Draw_Bitmap16(&background_bmp, back_buffer, back_lpitch,1);
	
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	DDraw_Flip();
	DSound_Play(sound_id[12]);


	// read keyboard
	Sleep(500);
a:
	DInput_Read_Keyboard();
	if (keyboard_state[DIK_SPACE])
	{
		if(Get_Clock() - time < 400)
			goto a;
		else
		{
			DSound_Stop_All_Sounds();
			HighScore(totscore);
			time = Get_Clock();
		}
	}
	else goto a; //read at 400ms increments
}
void kbInput()
{
	// read keyboard
	DInput_Read_Keyboard();	
	if (keyboard_state[DIK_LEFT]) // rotate left
		boat.BarrelLeft();
	if (keyboard_state[DIK_RIGHT]) // rotate right
		boat.BarrelRight();
	if (keyboard_state[DIK_UP])
	{
		if(Get_Clock() - last_shot_bullet < 400)
			return; //read at 400ms increments
		else
		{
			if(boat.FireWeaponUp()) //if fired, play sound
				DSound_Play(sound_id[7]);
			last_shot_bullet = Get_Clock();
		}
	}
	if (keyboard_state[DIK_DOWN])
	{
		if(Get_Clock() - last_shot_charge < 400)
			return; //read at 400ms increments
		else
		{
			if(boat.FireWeaponDown()) //if fired, play sound
				DSound_Play(sound_id[7]);
			last_shot_charge = Get_Clock();
		}
	}
	if (keyboard_state[DIK_Z]) //moves the boat to the left
		boat.MoveLeft();
	if (keyboard_state[DIK_X]) //moves the boat to the right
		boat.MoveRight();
}

void Detect1() //detect collisions between depth charges and submarines
{

	BOB tempbob;
	BOB tempbob2;

	for(int i=0; i< NUM_SUBMARINES; i++)
	{
		tempbob=boat.charge_one.bob();
		tempbob2=submarine[i].bob();
		tempbob2.x+=40; //offset the submarine because of bubble trail
		if(boat.charge_one.status && submarine[i].status==1)
			if(Collision_BOBS(&tempbob2,&tempbob))
			{ //depth charge 1
				score++;
				totscore++;
				submarine[i].Kill();
				boat.charge_one.Explode();
				DSound_Play(sound_id[6]);
			}

		tempbob=boat.charge_two.bob();
		if(boat.charge_two.status && submarine[i].status==1)
			if(Collision_BOBS(&tempbob2,&tempbob))
			{ //depth charge 2
				score++;
				totscore++;
				submarine[i].Kill();
				boat.charge_two.Explode();
				DSound_Play(sound_id[6]);
			}

		tempbob=boat.charge_three.bob();
		if(boat.charge_three.status && submarine[i].status==1)
			if(Collision_BOBS(&tempbob2,&tempbob))
			{ //depth charge 3
				score++;
				totscore++;
				submarine[i].Kill();
				boat.charge_three.Explode();
				DSound_Play(sound_id[6]);
			}
	}
}

void Detect2()  //detect collisions between bullets and planes
{

	BOB tempbob;
	BOB tempbob2;

	for(int i=0; i< NUM_PLANES; i++)
	{
		tempbob=boat.bullet_one.bob();
		tempbob2=plane[i].bob();
		tempbob2.x+=10; //offset the plane because of game lag
		if(boat.bullet_one.status && plane[i].status==1)
			if(Collision_BOBS(&tempbob2,&tempbob))
			{ // for bullet 1
				score++;
				totscore++;
				plane[i].Kill();
				boat.bullet_one.Explode();
				DSound_Play(sound_id[6]);
			}

		tempbob=boat.bullet_two.bob();
		if(boat.bullet_two.status && plane[i].status==1)
			if(Collision_BOBS(&tempbob2,&tempbob))
			{ //for bullet 2
				score++;
				totscore++;
				plane[i].Kill();
				boat.bullet_two.Explode();
				DSound_Play(sound_id[6]);
			}
	}
}

void DetectBoat() // detect collisions between falling planes and boat
{
	BOB tempbob;
	BOB tempbob2;

	for (int i=0; i< NUM_PLANES; i++)
	{
		tempbob=boat.bob();
		tempbob2=plane[i].bob();
		if(Collision_BOBS(&tempbob2,&tempbob))
		{
			if (boat.status==0 && plane[i].status==2)
			{
				plane[i].status=0;
				boat.status=1;
				boat.Draw();
				DSound_Play(sound_id[11]);
			}
			if (boat.status==1 && plane[i].status==2)
			{
				boat.status=2;
				plane[i].status=0;
				boat.Draw();
				DSound_Play(sound_id[11]);
			}
	
		} 
	}
}

void InitSounds()
{
	// load background sounds
	for(int i=0; i <12; i++) //init
		sound_id[i]=0;

	sound_id[0] = DSound_Load_WAV("sounds/sp066.wav"); //intro+inbetween screens
	sound_id[1] = DSound_Load_WAV("sounds/lvl1.wav"); //lvl1
	sound_id[2] = DSound_Load_WAV("sounds/lvl2.wav"); //lvl2
	sound_id[3] = DSound_Load_WAV("sounds/lvl3.wav"); //lvl3
	sound_id[4] = DSound_Load_WAV("sounds/lvl4.wav"); //lvl4
	sound_id[5] = DSound_Load_WAV("sounds/lvl5.wav"); //lvl5
	sound_id[6] = DSound_Load_WAV("sounds/EXP1.WAV");  //sub sink
	sound_id[7] = DSound_Load_WAV("sounds/HWEAPON1.WAV"); //shoot charge
	sound_id[8] = DSound_Load_WAV("sounds/sonar.wav"); //sub sonar
	sound_id[9] = DSound_Load_WAV("sounds/siren.wav"); //siren
	sound_id[10] = DSound_Load_WAV("sounds/engines.wav"); //siren
	sound_id[11] = DSound_Load_WAV("sounds/EXP2.WAV"); // boat damage/sink
	sound_id[12] = DSound_Load_WAV("sounds/GAMEOVER.WAV"); //siren
	sound_id[13] = DSound_Load_WAV("sounds/misscom1.wav"); //siren
	sound_id[14] = DSound_Load_WAV("sounds/take_cover.wav"); //siren
	sound_id[15] = DSound_Load_WAV("sounds/wind.wav"); //siren
}

void HighScore(int totscore)
{
	DWORD time=0;
	BITMAP_IMAGE background_bmp;
	int x=0;
	int temp;

	DDraw_Fill_Surface(lpddsback, 0);
	Load_Bitmap_File(&bitmap16bit, "graphics/water2.bmp");
	Create_Bitmap(&background_bmp,0,0,640,480,16);
	Load_Image_Bitmap16(&background_bmp, &bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
	Unload_Bitmap_File(&bitmap16bit);
	DDraw_Fill_Surface(lpddsback, 0);
	DDraw_Fill_Surface(lpddsprimary, 0);
	DDraw_Lock_Back_Surface();
	// draw background
	Draw_Bitmap16(&background_bmp, back_buffer, back_lpitch,0);
	
	// unlock back surface
	DDraw_Unlock_Back_Surface();
	Draw_Text_GDI("HIGHSCORES",314,80,RGB(255,255,255), lpddsback);
	
	highscores[5]=totscore;

	for (int j=4; j>=0; j--) //sort the high scores and add new one if necessary
	{
		if (highscores[j+1] > highscores[j])
		{
			temp = highscores[j];
			highscores[j] = highscores[j+1];
			highscores[j+1] = temp;
		}
	}
	inFile.close();
	ofstream outFile;  //output the new high scores
	outFile.open("highscores.dat");
		
	for (x=0; x<5;x++)
	{
		sprintf(buffer, "%d Points", highscores[x]);
		Draw_Text_GDI(buffer,314, 100+20*x,RGB(255,255,255), lpddsback);
		outFile << highscores[x] << endl;
	}
	sprintf(buffer, "Your score is %d", totscore);

	Draw_Text_GDI(buffer, 314,200,RGB(255,0,0), lpddsback);

	Draw_Text_GDI("Press [SPACE] to start over",314,260,RGB(255,255,255), lpddsback);
	Draw_Text_GDI("Press [ESC] to quit",314,280,RGB(255,255,255),lpddsback);
	DDraw_Flip();

	Sleep(500);
a:
		DInput_Read_Keyboard();
		if (keyboard_state[DIK_SPACE])
		{
			if(Get_Clock() - time < 400)
				goto a; //read every 400ms
			else
			{  //reset all variables to initial state
				score =0;
				totscore=0;
				level=0;
				boat.status=0;
				gotpast=0;
				firstrun=true;
				boat.charge_one.status=0;
				boat.charge_two.status=0;
				boat.charge_three.status=0;
				boat.bullet_one.status=0;
				boat.bullet_two.status=0;
				active1=0;
				active2=1;
				active21=0;
				active22=1;
				boat.pos_x=320;
				time = Get_Clock();
				DDraw_Fill_Surface(lpddsback, 0);
				DDraw_Fill_Surface(lpddsprimary, 0);
				boat.MoveLeft();
			}
		}
		else if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
		{
			if(Get_Clock() - time < 400)
				goto a;
			else
			{
				level=11; //quits the game
				PostMessage(main_window_handle, WM_DESTROY,0,0);
		
				// stop all sounds
				DSound_Stop_All_Sounds();
				time = Get_Clock();
			}
		}
		else goto a;
}






