#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "sub1.h"

//Default Constructor
sub1::sub1()
{
	
	status=0;
}

//Default Destructor
sub1::~sub1()
{
	Destroy_BOB(&submarine);
}

BOB sub1::bob()
{
	BOB temp;
	temp= submarine;
	return temp;
}

//Creates a submarine
void sub1::Create()
{
	int index=0;
	// load the bitmaps
	Load_Bitmap_File(&bitmap16bit, "graphics/submarine1.bmp");
	
	// create bob
	Create_BOB(&submarine,0,0,170,32,1,BOB_ATTR_MULTI_FRAME | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY,0,16);
	Set_Anim_Speed_BOB(&submarine, 1);

	Set_Vel_BOB(&submarine, 2+rand()%3,0);
	Load_Frame_BOB16(&submarine, &bitmap16bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

	//set the initial position of the submarine off of the screen
	Set_Pos_BOB(&submarine, submarine.width * -1 , SCREEN_HEIGHT-submarine.height-rand()%150);
		
	Unload_Bitmap_File(&bitmap16bit);
	status=1;
}

//Destroys, Kill, and Removes a submarine
void sub1::Kill()
{
	int x=0,y=0;
	if (status!=0)  //0 means dont draw
	{
		if(submarine.y>SCREEN_HEIGHT)  //remove the bob when it is off of the screen after being hit
		{
			Destroy_BOB(&submarine);
			status=0;
		}
		else
		{
			if (status==1) //submarine is moving and got hit
			{
				x=submarine.x;
				y=submarine.y;
				Load_Bitmap_File(&bitmap16bit, "graphics/submarine2.bmp");
				// create bob
				Create_BOB(&submarine,x,y,170,32,3,BOB_ATTR_MULTI_FRAME | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY,0,16);
				Set_Anim_Speed_BOB(&submarine, 1);
				Set_Vel_BOB(&submarine, 1,2);
				for (int index=0; index < 3; index++)
					Load_Frame_BOB16(&submarine, &bitmap16bit, index, 0, index, BITMAP_EXTRACT_MODE_CELL);
				status=2; // hit and sinking
			}
			else  //draw the submarine
			{
				Move_BOB(&submarine);
				Animate_BOB(&submarine);
				Draw_BOB16(&submarine,lpddsback);
			}
		}
	}
	else
		Destroy_BOB(&submarine);
}

int sub1::GetPosition() //gets the x position of the BOB
{
	return submarine.x;
}

//Moves a submarine across the screen
void sub1::Move()
{
	// move the chopper
	Move_BOB(&submarine);
	// test for off the screen wrap around
	if (submarine.x > SCREEN_WIDTH)
		submarine.x = -submarine.width;
	Draw_BOB16(&submarine,lpddsback);
	status=1; //moving	
}

